# ubuntuone.platform.windows- windows platform imports
#
# Author: Manuel de la Pena <manuel@canonical.com>
#
# Copyright 2011 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.

"""Windows tools to interact with the os."""

from contextlib import contextmanager

platform = 'win32'


def set_file_readonly(path):
    """Change path permissions to readonly in a file."""

def set_file_readwrite(path):
    """Change path permissions to readwrite in a file."""

def set_dir_readonly(path):
    """Change path permissions to readonly in a dir."""

def set_dir_readwrite(path):
    """Change path permissions to readwrite in a dir."""

@contextmanager
def allow_writes(path):
    """A very simple context manager to allow writting in RO dirs."""

def remove_file(path):
    """Remove a file."""

def remove_dir(path):
    """Remove a dir."""

def path_exists(path):
    """Return if the path exists."""

def make_dir(path, recursive=False):
    """Make a dir, optionally creating all the middle ones."""

def open_file(path, mode='r'):
    """Open a file."""

def rename(path_from, path_to):
    """Rename a file or directory."""

def listdir(directory):
    """List a directory."""

def access(path):
    """Return if the path is at least readable."""

def stat_path(path):
    """Return stat info about a path."""
